uses Crt, Graph;
var
  XMin     :real;
  XMax     :real;
  Ymin     :real;
  Ymax     :real;
  grDriver : Integer;
  grMode   : Integer;
  ErrCode  : Integer;
  I        : integer;
  X,Y      : real;
  Dil      : integer;
  T        : INTEGER;
  C        : char;

Function XG(XX:real):longint;{Transformuje realne souradnice na graficke}
  begin
    XG:=Round(GetMaxX*(XX-XMin)/(XMax-XMin));
  end;{XG}
Function YG(YY:real):longint;{Transformuje realne souradnice na graficke}
  begin
    YG:=GetMaxY-Round(GetMaxY*(YY-YMin)/(YMax-YMin));
  end;{YG}
Procedure Frame; {Ramecek okolo zobrazene plochy}
  begin
    Rectangle(0,0,GetmaxX,GetMaxY);
  end;{Frame}
procedure RASTER(Color:word);
  var
    CurrColor:word;
    XText,YText : String;
    I:integer;
  begin
    CurrColor:=GetColor; {Uchov aktuln barvu v hlavnm programu}
    SetColor(Color);
    SetLineStyle(SolidLn,0,ThickWidth);
    Frame;                                {Rmeek}
    SetLineStyle(SolidLn,0,NormWidth);
    Line(XG(XMin),YG(0),XG(XMax),YG(0));  {vodorovn osa}
    Line(XG(0),YG(YMin),XG(0),YG(YMax));  {svisl osa}
    Dil:=4;
    for I:=0 to dil do
    begin
      STR(I*XMax/Dil:4:2,XText);
      STR(I*YMax/Dil:4:2,YText);
      MoveTo(XG(I*XMax/Dil),YG(0));       {rky na ose}
      MoveRel(0,-5);
      LineRel(0,10);
      OutText(XText);                     {Popis osy X}
      MoveTo(XG(-(I*XMax/Dil)),YG(0));
      MoveRel(0,-5);
      LineRel(0,10);
      If I>0 then OutText('-');           {minus}
      OutText(XText);                     {Popis osy X}
      MoveTo(XG(0),YG(I*YMax/Dil));
      MoveRel(-5,0);
      LineRel(10,0);
      MoveRel(0,3);
      if I>0 then OutText(YText);         {Popis osy Y}
      MoveTo(XG(0),YG(-(I*YMax/Dil)));
      MoveRel(-5,0);
      LineRel(10,0);
      If I>0 then
      begin
        MoveRel(0,-8);
        OutText('-');                     {minus}
        OutText(YText);
      end;{If}
    end;{For I}
    SetColor(CurrColor); {Nastav barvu, jak myla pi startu procedury}
  end;{Raster}
procedure DrawSinus;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(LightBlue);
    X:=XMIN;
    Y:=SIN(X);
    MoveTO(XG(X),YG(Y));
    While X<=Xmax do
    begin
      X:=X+2*pi/360;
      Y:=SIN(X);
      PutPixel(XG(X),YG(Y),LightRed); {Kresleni pixly (red)}
{      LineTo(XG(X),YG(Y+0.1));     }{ Druha metoda kresleni usecky blue}
    end;{While}
    C:=ReadKey;
  end;
procedure DrawArchimedesSpirale;
{Ro:=A*Fi}
  const
    A=1.0;
  var
    Ro,Fi:real;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(LightBlue);
    Fi:=0;
    Ro:=A*Fi;
    X:=Ro*Cos(Fi);
    Y:=Ro*sin(Fi);
    MoveTO(XG(X),YG(Y));
    While Fi < 6*360*Pi/180 do
    begin
      FI:=Fi+5*pi/180;
      Ro:=A*Fi;
      X:=Ro*Cos(Fi);
      Y:=Ro*sin(Fi);
{      PutPixel(XG(X),YG(Y),LightGreen);}
      LineTo(XG(X),YG(Y));
    end;{While}
    C:=ReadKey;;
  end;
procedure DrawLogSpirale;
{Ro:=A*exp(B*Fi)}
  const
    A=0.1;
    B=0.1;
  var
    Ro,Fi:real;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    Ro:=A*exp(B*Fi);
    X:=Ro*Cos(Fi);
    Y:=Ro*sin(Fi);
    MoveTO(XG(X),YG(Y));
    While Fi < 6*360*Pi/180 do
    begin
      FI:=Fi+5*pi/180;
      Ro:=A*exp(B*Fi);
      X:=Ro*Cos(Fi);
      Y:=Ro*sin(Fi);
{      PutPixel(XG(X),YG(Y),LightGreen);}
      LineTo(XG(X),YG(Y));
    end;{While}
    C:=ReadKey;;
  end;

procedure DrawCardio;
{
 x:=A*cos(T*(T+cos(T));
 y:=A*sin(T*(1+cos(T));}
  const
    A=1;
  var
    Ro,Fi:real;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    Ro:=A*(1+cos(FI));
    X:=Ro*cos(Fi);
    Y:=Ro*Sin(Fi);
    MoveTO(XG(X),YG(Y));
    While Fi < 360*Pi/180 do
    begin
      Fi:=Fi+5*pi/180;
      Ro:=A*(1+cos(FI));
      X:=Ro*cos(Fi);
      Y:=Ro*Sin(Fi);
      LineTo(XG(X),YG(Y));
    end;{While}
    C:=ReadKey;;
  end;
procedure DrawCruciform;
  const
    A=1;
  var
    Ro,Fi:real;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    if Sin(2*Fi)<>0 then Ro:=2*A/sin(2*Fi);
    X:=Ro*cos(Fi);
    Y:=Ro*Sin(Fi);
    MoveTO(XG(X),YG(Y));
    While Fi < 360*Pi/180 do
    begin
      Fi:=Fi+pi/1800;
      if Sin(2*Fi)<>0 then Ro:=2*A/sin(2*Fi);
      X:=Ro*cos(Fi);
      Y:=Ro*Sin(Fi);
      If ABS(Ro)<maxint then   PutPixel(XG(X),YG(Y),LightGreen);
    end;{While}
    C:=ReadKey;;
  end;
procedure   DrawEpiCykloide;
  const
    A=0.5;
    B=4.0;
    L=2;
  var
    Fi:real;
  begin
    ClearDevice;
    RASTER(LightGreen);
    SetColor(Yellow);
    Fi:=0;
    X:=(A+B)*cos(Fi)-L*a*cos((A+B)*Fi/A);
    Y:=(A+B)*sin(Fi)-L*a*sin((A+B)*Fi/A);
    MoveTO(XG(X),YG(Y));
    While Fi < 360*Pi/180 do
    begin
      Fi:=Fi+pi/180;
      X:=(A+B)*cos(Fi)-L*a*cos((A+B)*Fi/A);
      Y:=(A+B)*sin(Fi)-L*a*sin((A+B)*Fi/A);
      LineTo(XG(X),YG(Y));
    end;{While}
    C:=ReadKey;;
  end;

begin  {  =========================   Main ==========================  }

  grDriver := Detect;
  InitGraph(grDriver, grMode,'c:\BP\bgi');
  ErrCode := GraphResult;
  if ErrCode <> grOk then exit;

  XMin := -2*pi;
  XMax := 2*pi;
  YMax := 2;
  YMin := -2;
  DrawSinus;
  XMin:=-16*pi;
  XMax:=16*pi;
  Ymin:=-12*pi;
  Ymax:=12*pi;
  DrawArchimedesSpirale;
  XMin:=-4;
  XMax:=4;
  Ymin:=-3;
  Ymax:=3;
  DrawLogSpirale;
  XMin:=-2;
  XMax:=2;
  Ymin:=-1.5;
  Ymax:=1.5;
  DrawCardio;
  XMin:=-16;
  XMax:=16;
  Ymin:=-12;
  Ymax:=12;
  DrawCruciform;
  DrawEpiCykloide;

{  SetBkColor(Blue);
  Line(0,0,GetMaxX,GetMaxY);
  ClearDevice;
  ClearViewPort;
  C:=ReadKey;;              }
  CloseGraph;

end.
{Dodlat jednotliv kivky jako procedury}
